package com.yidianling.course.widget

import android.annotation.SuppressLint
import android.content.Context
import android.graphics.Paint
import android.support.constraint.ConstraintLayout
import android.text.TextUtils
import android.util.AttributeSet
import android.view.View
import com.alibaba.android.arouter.launcher.ARouter
import com.ydl.ydl_image.module.GlideApp
import com.yidianling.common.tools.RxImageTool
import com.yidianling.course.CourseConstants
import com.yidianling.course.R
import com.yidianling.course.coursePlay.moudle.Course
import com.yidianling.ydlcommon.h5.H5Params
import com.yidianling.ydlcommon.h5.NewH5Activity
import com.yidianling.ydlcommon.player.YDLMusicHelper
import com.yidianling.ydlcommon.utils.PlayerFloatHelper
import com.yidianling.ydlcommon.utils.actionutil.ActionCountUtils
import com.yidianling.ydlcommon.utils.actionutil.BIConstants
import com.yidianling.ydlcommon.view.PlayerFloatView
import kotlinx.android.synthetic.main.item_course_new_list_view.view.*

/**
 * @author jiucheng
 * @描述:课程列表页改版后的itemView
 * @Copyright Copyright (c) 2018
 * @Company 壹点灵
 * @date 2019/8/13
 */
class CourseItemNewView : ConstraintLayout {
    private var mContext: Context
    private lateinit var course: Course
    private var statusListener: PlayerFloatView.FloatViewPlayListener? = null
    private var headUrl: String = ""
    private var doctorName: String = ""

    constructor(mContext: Context) : super(mContext) {
        this.mContext = mContext
        initView()
    }

    constructor(mContext: Context, arrt: AttributeSet) : super(mContext, arrt) {
        this.mContext = mContext
        initView()
    }


    fun initView() {
        View.inflate(mContext, R.layout.item_course_new_list_view, this)
        var parmas = LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.WRAP_CONTENT)
        layoutParams = parmas
        setPadding(RxImageTool.dp2px(13f), 0, RxImageTool.dp2px(15f), 0)
    }

    @SuppressLint("SetTextI18n")
    fun setData(course: Course) {
        this.course = course
        if (!TextUtils.isEmpty(course.hostListPic)) {
            headUrl = course.hostListPic
        } else {
            if (course.courseHostInfo != null && !TextUtils.isEmpty(course.courseHostInfo.doctorHead)) {
                headUrl = course.courseHostInfo.doctorHead
            }
        }

        GlideApp.with(mContext)
                .load(headUrl)
                .into(iv_head)

        tv_title.text = course.title
        if (!TextUtils.isEmpty(course.doctorName)) {
            doctorName = course.doctorName
        } else {
            if (course.courseHostInfo != null && !TextUtils.isEmpty(course.courseHostInfo.doctorName)) {
                doctorName = course.courseHostInfo.doctorName
            }
        }
        var info = ""
        if (!TextUtils.isEmpty(course.hostInfo)) {
            info = course.hostInfo
        } else {
            if (course.courseHostInfo != null && !TextUtils.isEmpty(course.courseHostInfo.title)) {
                info = course.courseHostInfo.title
            }
        }

        if (TextUtils.isEmpty(doctorName) || TextUtils.isEmpty(info)) {
            tv_doctor_info.text = "壹点灵课程精选讲师"
        } else {
            tv_doctor_info.text = "$doctorName · $info"
        }

        tv_course_info.text = "共${course.subCourseNum}讲"
        tv_course_num.text = "${course.joinNum}人已学"
        if (course.subCourseNum == 0) {
            tv_course_info.visibility = View.GONE
            view_line.visibility = View.GONE
        } else {
            tv_course_info.visibility = View.VISIBLE
            view_line.visibility = View.VISIBLE
        }

        if (course.isInvite == 0) {
            tv_fan_li.visibility = View.GONE
        } else {
            tv_fan_li.visibility = View.VISIBLE
        }

        if (course.newCourse == 1) {
            iv_new.visibility = View.VISIBLE
        } else {
            iv_new.visibility = View.GONE
        }

        if (course.recommend == 2) {
            iv_hot.visibility = View.VISIBLE
        } else {
            iv_hot.visibility = View.GONE
        }

        if (course.demoType == 0) {
            iv_play.visibility = View.GONE
        } else {
            iv_play.visibility = View.VISIBLE
        }

        iv_play.setOnClickListener {
            playMedia()

            ActionCountUtils.count(BIConstants.CourseListEvent.POSITION_COURSE_LIST_AUDITION_CLICK, course.id)
        }

        tv_view_course.setOnClickListener {
            if (TextUtils.equals(course.courseType, "1") || TextUtils.equals(course.courseType, "7") || TextUtils.equals(course.courseType, "6")) {
                ARouter.getInstance()
                        .build("/course/play")
                        .withInt("course_id", course.id.toInt())
                        .navigation()
            } else {
                val h5Params = H5Params(CourseConstants.COURSE_DETAIL_H5 + course.id, "课程详情")
                NewH5Activity.start(mContext, h5Params)
            }

            ActionCountUtils.count(BIConstants.CourseListEvent.POSITION_COURSE_LIST_XXX_CLICK + course.id + "_click")
        }


        if (!TextUtils.isEmpty(course.applyFee)) {
            if (course.applyFee.contains(".")) {
                tv_price.text = course.applyFee.split(".")[0]
                tv_price_decimal.text = "." + course.applyFee.split(".")[1]
            } else {
                tv_price.text = course.applyFee
                tv_price_decimal.text = ".00"
            }
        }

        if (TextUtils.equals("1", course.isPromotion) || TextUtils.equals("3", course.isPromotion)) {
            tv_cu_xiao.visibility = View.VISIBLE
            if (TextUtils.equals("1", course.isPromotion)) {
                if (course.promotionApplyFee.contains(".")) {
                    tv_price.text = course.promotionApplyFee.split(".")[0]
                    tv_price_decimal.text = "." + course.promotionApplyFee.split(".")[1]
                } else {
                    tv_price.text = course.promotionApplyFee
                    tv_price_decimal.text = ".00"
                }
            }
        } else {
            tv_cu_xiao.visibility = View.GONE
        }

        if (course.isBuy) {
            tv_view_course.visibility = View.VISIBLE
            if (TextUtils.equals(course.courseType, "1") || TextUtils.equals(course.courseType, "7") || TextUtils.equals(course.courseType, "6")) {
                tv_view_course.text = "立即听课"
            } else {
                tv_view_course.text = "查看课程"
            }


            tv_original_price.visibility = View.GONE
            tv_price_si.visibility = View.GONE
            tv_price.visibility = View.GONE
            tv_price_decimal.visibility = View.GONE
        } else {
            tv_view_course.visibility = View.GONE

            tv_original_price.visibility = View.VISIBLE
            tv_price_si.visibility = View.VISIBLE
            tv_price.visibility = View.VISIBLE
            tv_price_decimal.visibility = View.VISIBLE


            if (TextUtils.isEmpty(course.originalApplyFee) || TextUtils.equals(course.originalApplyFee, "0") || TextUtils.equals(course.originalApplyFee, "0.0") || TextUtils.equals(course.originalApplyFee, "0.00")) {
                tv_original_price.visibility = View.GONE
            } else {
                tv_original_price.visibility = View.VISIBLE
            }
            tv_original_price.text = "¥" + course.originalApplyFee
            tv_original_price.paint.flags = Paint.STRIKE_THRU_TEXT_FLAG

        }
    }

    private fun playMedia() {
        if (PlayerFloatHelper.isShow(mContext)) {
            PlayerFloatHelper.hide()
            PlayerFloatHelper.removeView(mContext)
            YDLMusicHelper.clearTempData()
            YDLMusicHelper.stop()
        } else {
            PlayerFloatHelper.removeView(mContext)
        }


        YDLMusicHelper.title = course.title
        YDLMusicHelper.name = doctorName
        YDLMusicHelper.cover = if (!TextUtils.isEmpty(course.image)) course.image else course.pic
        YDLMusicHelper.course_id = course.id.toInt()
        YDLMusicHelper.isCanClick = false

        if (course.demoType == 1) {
            YDLMusicHelper.playType = 0
            PlayerFloatHelper.show(mContext)

            YDLMusicHelper.coursePlay(course.demoFile)
        }
        if (course.demoType == 2) {
            YDLMusicHelper.playType = 1
            YDLMusicHelper.courseVideoUlr = course.demoFile

            PlayerFloatHelper.show(mContext)
        }


        if (statusListener == null) {
            statusListener = object : PlayerFloatView.FloatViewPlayListener {
                override fun onStartClick() {
                }

                override fun onPlayFinish() {
                    PlayerFloatHelper.hide()
                    YDLMusicHelper.clearTempData()
                    YDLMusicHelper.stop()
                }

                override fun onPauseClick() {
                }

            }
            PlayerFloatHelper.addClickListener(statusListener as PlayerFloatView.FloatViewPlayListener)
        }
    }


    fun setBottomLineGone() {
        view_bottom_line.visibility = View.INVISIBLE
    }

    fun setBottomLineVisible() {
        view_bottom_line.visibility = View.VISIBLE
    }

    fun hideListenerButton() {
        tv_view_course.visibility = View.GONE
    }
}